<template>
    <NuxtLayout :name="'dashboard'">
        <div class="flex justify-evenly container p-8">
            <div class="p-2 my-12 rounded-lg lg:w-1/3 xl:1/2 h-fit border-solid border-slate-300 border-2">
                <!-- <DynamicForm :fields="fields" :formTitle="formTitle" :submitName="submitName" :onSubmit="onSubmit" /> -->
                <form class="p-2" @submit.prevent="onSubmit">
                    <h2 class="w-full text-center mb-4 text-xl font-semibold">
                        {{ formTitle }}
                    </h2>
                    <div class="mb-4">
                        <label for="file" class="block text-sm font-medium text-gray-700">Document</label>
                        <input type="file" id="file" name="file" @change="onFileChange" accept=".pdf"
                            class="w-full px-4 py-2 border rounded-lg focus:outline-none focus:ring focus:border-blue-300"
                            :placeholder="`Enter your Document's File`" />
                    </div>
                    <button type="submit"
                        class="w-full py-2 px-4 mt-4 bg-blue-500 text-white rounded-lg hover:bg-blue-600 active:bg-blue-900">
                        <span v-if="isLoading">
                            <Icon name="eos-icons:bubble-loading" class="w-5 h-5" />
                            {{ submitName }}
                        </span>
                        <span v-else>
                            <Icon name="ic:round-search" class="w-5 h-5" />
                            {{ submitName }}
                        </span>
                    </button>
                </form>
            </div>
        </div>
    </NuxtLayout>
</template>
  
<script lang="ts">

definePageMeta({
    middleware: ["auth"],
});

export default {
    data() {
        return {
            formTitle: "Pay Funding",
            submitName: "Save",
            isLoading: false,
            fundingId: '',
            form: {
                prove: null as File | null,
            },
            fields: [
                { id: "prove", name: "Payment Prove", type: "file", value: "" },
            ],
        };
    },
    mounted() {
        this.fundingId = this.$route.params.funding_id as string;
        // this.fetchData();
    },
    methods: {
        // fetchData() {
        //     const toastStore = useToastStore();
        //     const accessToken: string = localStorage.getItem("access_token")!;
        //     this.$api.get(`/payment/${this.fundingId}`,
        //         {
        //             headers: {
        //                 'Accept': 'application/json',
        //                 'Authorization': `Bearer ${accessToken}`,
        //             },
        //         })
        //         .then((response) => {
        //             const data = response.data;
        //             this.form.title = data.title;
        //             this.form.description = data.description;
        //             this.status = data.status;
        //             this.formToField(response.data);
        //         })
        //         .catch((error) => {
        //             console.log(error)
        //         })
        // },
        onSubmit() {
            this.isLoading = true;
            const toastStore = useToastStore();
            const accessToken: string = localStorage.getItem("access_token")!;

            if (!this.form.prove) {
                toastStore.showToast('No file selected', 'danger');
                this.isLoading = false;
                return;
            }
            let formData = new FormData();
            formData.append('file', this.form.prove);

            this.$api
                .post(`/payment/${this.fundingId}/funding`,
                    formData,
                    {
                        headers: {
                            'Accept': 'application/json',
                            'Authorization': `Bearer ${accessToken}`,
                            'Content-Type': 'multipart/form-data',
                        },
                    }
                )
                .then((response) => {
                    console.log(response);
                    toastStore.showToast('success', "Data stored successfully");
                    this.$router.replace("/funding");
                })
                .catch((error) => {
                    console.log(error);
                    const detail = error.response.data.detail;
                    let message = "";
                    if (detail[0].msg) {
                        message = detail[0].msg;
                    } else {
                        message = detail;
                    }
                    toastStore.showToast(message, 'danger');
                }).finally(() => {
                    this.isLoading = false;
                })
        },
        onFileChange(event: Event) {
            const input = event.target as HTMLInputElement
            if (input.files && input.files.length > 0) {
                this.form.prove = input.files[0]
            } else {
                this.form.prove = null
            }
        },
    },
};
</script>
  